Index: trunk/NEMO/LIM_SRC_2/limdyn_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limdyn_2.F90	(revision 833)
+++ trunk/NEMO/LIM_SRC_2/limdyn_2.F90	(revision 888)
@@ -4,4 +4,9 @@
    !!   Sea-Ice dynamics :  
    !!======================================================================
+   !! History :   1.0  !  01-04  (LIM)  Original code
+   !!             2.0  !  02-08  (C. Ethe, G. Madec)  F90, mpp
+   !!             2.0  !  03-08  (C. Ethe) add lim_dyn_init
+   !!             2.0  !  06-07  (G. Madec)  Surface module
+   !!---------------------------------------------------------------------
 #if defined key_lim2
    !!----------------------------------------------------------------------
@@ -11,31 +16,32 @@
    !!    lim_dyn_init_2 : initialization and namelist read
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE phycst
-   USE in_out_manager  ! I/O manager
-   USE dom_ice_2
-   USE dom_oce         ! ocean space and time domain
-   USE ice_2
-   USE ice_oce
-   USE iceini_2
-   USE limistate_2
-   USE limrhg_2        ! ice rheology
-   USE lbclnk
-   USE lib_mpp
-   USE prtctl          ! Print control
+   USE dom_oce        ! ocean space and time domain
+   USE sbc_oce        !
+   USE phycst         !
+   USE ice_2          !
+   USE ice_oce        !
+   USE dom_ice_2      !
+   USE iceini_2       !
+   USE limistate_2    !
+   USE limrhg_2       ! ice rheology
+
+   USE lbclnk         !
+   USE lib_mpp        !
+   USE in_out_manager ! I/O manager
+   USE prtctl         ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC lim_dyn_2  ! routine called by ice_step
+   PUBLIC   lim_dyn_2 ! routine called by sbc_ice_lim
 
    !! * Module variables
    REAL(wp)  ::  rone    = 1.e0   ! constant value
 
-   !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2006) 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -46,5 +52,5 @@
       !!               ***  ROUTINE lim_dyn_2  ***
       !!               
-      !! ** Purpose :   compute ice velocity and ocean-ice stress
+      !! ** Purpose :   compute ice velocity and ocean-ice friction velocity
       !!                
       !! ** Method  : 
@@ -52,39 +58,27 @@
       !! ** Action  : - Initialisation
       !!              - Call of the dynamic routine for each hemisphere
-      !!              - computation of the stress at the ocean surface         
+      !!              - computation of the friction velocity at the sea-ice base
       !!              - treatment of the case if no ice dynamic
-      !! History :
-      !!   1.0  !  01-04  (LIM)  Original code
-      !!   2.0  !  02-08  (C. Ethe, G. Madec)  F90, mpp
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt     ! number of iteration
-
-      INTEGER ::   ji, jj             ! dummy loop indices
-      INTEGER ::   i_j1, i_jpj        ! Starting/ending j-indices for rheology
-      REAL(wp) ::   &
-         ztairx, ztairy,           &  ! tempory scalars
-         zsang , zmod,             &
-         ztglx , ztgly ,           &
-         zt11, zt12, zt21, zt22 ,  &
-         zustm, zsfrld, zsfrldm4,  &
-         zu_ice, zv_ice, ztair2
-      REAL(wp),DIMENSION(jpj) ::   &
-         zind,                     &  ! i-averaged indicator of sea-ice
-         zmsk                         ! i-averaged of tmask
+      !!
+      INTEGER  ::   ji, jj             ! dummy loop indices
+      INTEGER  ::   i_j1, i_jpj        ! Starting/ending j-indices for rheology
+      REAL(wp) ::   zcoef              ! temporary scalar
+      REAL(wp), DIMENSION(jpj)     ::   zind           ! i-averaged indicator of sea-ice
+      REAL(wp), DIMENSION(jpj)     ::   zmsk           ! i-averaged of tmask
+      REAL(wp), DIMENSION(jpi,jpj) ::   zu_io, zv_io   ! ice-ocean velocity
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000  )   CALL lim_dyn_init_2   ! Initialization (first time-step only)
+      IF( kt == nit000 )   CALL lim_dyn_init_2   ! Initialization (first time-step only)
       
-      IF ( ln_limdyn ) THEN
-
+      IF( ln_limdyn ) THEN
+         !
          ! Mean ice and snow thicknesses.          
          hsnm(:,:)  = ( 1.0 - frld(:,:) ) * hsnif(:,:)
          hicm(:,:)  = ( 1.0 - frld(:,:) ) * hicif(:,:)
-
-         u_oce(:,:)  = u_io(:,:) * tmu(:,:)
-         v_oce(:,:)  = v_io(:,:) * tmu(:,:)
-       
-         !                                         ! Rheology (ice dynamics)
-         !                                         ! ========
+         !
+         !                                     ! Rheology (ice dynamics)
+         !                                     ! ========
          
          !  Define the j-limits where ice rheology is computed
@@ -94,17 +88,14 @@
             i_j1 = 1   
             i_jpj = jpj
-            IF(ln_ctl)    THEN
-               CALL prt_ctl_info('lim_dyn  :    i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj)
-            ENDIF
+            IF(ln_ctl)   CALL prt_ctl_info( 'lim_dyn  :    i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj )
             CALL lim_rhg_2( i_j1, i_jpj )
-
+            !
          ELSE                                 ! optimization of the computational area
-
+            !
             DO jj = 1, jpj
                zind(jj) = SUM( frld (:,jj  ) )   ! = FLOAT(jpj) if ocean everywhere on a j-line
                zmsk(jj) = SUM( tmask(:,jj,1) )   ! = 0          if land  everywhere on a j-line
-   !!i         write(numout,*) narea, 'limdyn' , jj, zind(jj), zmsk(jj)
-            END DO
-
+            END DO
+            !
             IF( l_jeq ) THEN                     ! local domain include both hemisphere
                !                                 ! Rheology is computed in each hemisphere
@@ -118,7 +109,7 @@
                i_j1 = MAX( 1, i_j1-1 )
                IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : NH i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
-    
+               ! 
                CALL lim_rhg_2( i_j1, i_jpj )
-    
+               ! 
                ! Southern hemisphere
                i_j1  =  1 
@@ -129,7 +120,7 @@
                i_jpj = MIN( jpj, i_jpj+2 )
                IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : SH i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
-    
+               ! 
                CALL lim_rhg_2( i_j1, i_jpj )
-    
+               ! 
             ELSE                                 ! local domain extends over one hemisphere only
                !                                 ! Rheology is computed only over the ice cover
@@ -148,105 +139,47 @@
     
                IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : one hemisphere: i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
-    
+               ! 
                CALL lim_rhg_2( i_j1, i_jpj )
-
+               !
             ENDIF
-
+            !
          ENDIF
 
-         IF(ln_ctl)   THEN 
-            CALL prt_ctl(tab2d_1=u_oce , clinfo1=' lim_dyn  : u_oce :', tab2d_2=v_oce , clinfo2=' v_oce :')
-            CALL prt_ctl(tab2d_1=u_ice , clinfo1=' lim_dyn  : u_ice :', tab2d_2=v_ice , clinfo2=' v_ice :')
-         ENDIF
-         
-         !                                         ! Ice-Ocean stress
-         !                                         ! ================
+         IF(ln_ctl)   CALL prt_ctl(tab2d_1=ui_ice , clinfo1=' lim_dyn  : ui_ice :', tab2d_2=vi_ice , clinfo2=' vi_ice :')
+         
+         ! computation of friction velocity
+         ! --------------------------------
+         ! ice-ocean velocity at U & V-points (ui_ice vi_ice at I-point ; ssu_m, ssv_m at U- & V-points)
+         
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               zu_io(ji,jj) = 0.5 * ( ui_ice(ji+1,jj+1) + ui_ice(ji+1,jj  ) ) - ssu_m(ji,jj)
+               zv_io(ji,jj) = 0.5 * ( vi_ice(ji+1,jj+1) + vi_ice(ji  ,jj+1) ) - ssv_m(ji,jj)
+            END DO
+         END DO
+         ! frictional velocity at T-point
          DO jj = 2, jpjm1
-            zsang  = SIGN(1.e0, gphif(1,jj-1) ) * sangvg
-            DO ji = 2, jpim1
-               ! computation of wind stress over ocean in X and Y direction
-#if defined key_coupled && defined key_lim_cp1
-               ztairx =  frld(ji-1,jj  ) * gtaux(ji-1,jj  ) + frld(ji,jj  ) * gtaux(ji,jj  )      &
-                  &    + frld(ji-1,jj-1) * gtaux(ji-1,jj-1) + frld(ji,jj-1) * gtaux(ji,jj-1)
-
-               ztairy =  frld(ji-1,jj  ) * gtauy(ji-1,jj  ) + frld(ji,jj  ) * gtauy(ji,jj  )      &
-                  &    + frld(ji-1,jj-1) * gtauy(ji-1,jj-1) + frld(ji,jj-1) * gtauy(ji,jj-1)
-#else
-               zsfrld  = frld(ji,jj) + frld(ji-1,jj) + frld(ji-1,jj-1) + frld(ji,jj-1)
-               ztairx  = zsfrld * gtaux(ji,jj)
-               ztairy  = zsfrld * gtauy(ji,jj)
-#endif
-               zsfrldm4 = 4 - frld(ji,jj) - frld(ji-1,jj) - frld(ji-1,jj-1) - frld(ji,jj-1)
-               zu_ice   = u_ice(ji,jj) - u_oce(ji,jj)
-               zv_ice   = v_ice(ji,jj) - v_oce(ji,jj)
-               zmod     = SQRT( zu_ice * zu_ice + zv_ice * zv_ice ) 
-               ztglx   = zsfrldm4 * rhoco * zmod * ( cangvg * zu_ice - zsang * zv_ice ) 
-               ztgly   = zsfrldm4 * rhoco * zmod * ( cangvg * zv_ice + zsang * zu_ice ) 
-
-               tio_u(ji,jj) = - ( ztairx + 1.0 * ztglx ) / ( 4 * rau0 )
-               tio_v(ji,jj) = - ( ztairy + 1.0 * ztgly ) / ( 4 * rau0 )
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               ust2s(ji,jj) = 0.5 * cw                                                          &
+                  &         * (  zu_io(ji,jj) * zu_io(ji,jj) + zu_io(ji-1,jj) * zu_io(ji-1,jj)   &
+                  &            + zv_io(ji,jj) * zv_io(ji,jj) + zv_io(ji,jj-1) * zv_io(ji,jj-1)   ) * tms(ji,jj)
             END DO
          END DO
-         
-         ! computation of friction velocity
+         !
+      ELSE      ! no ice dynamics : transmit directly the atmospheric stress to the ocean
+         !
+         zcoef = SQRT( 0.5 ) / rau0
          DO jj = 2, jpjm1
-            DO ji = 2, jpim1
-
-               zu_ice   = u_ice(ji-1,jj-1) - u_oce(ji-1,jj-1)
-               zv_ice   = v_ice(ji-1,jj-1) - v_oce(ji-1,jj-1)
-               zt11  = rhoco * ( zu_ice * zu_ice + zv_ice * zv_ice )
-
-               zu_ice   = u_ice(ji-1,jj) - u_oce(ji-1,jj)
-               zv_ice   = v_ice(ji-1,jj) - v_oce(ji-1,jj)
-               zt12  = rhoco * ( zu_ice * zu_ice + zv_ice * zv_ice ) 
-
-               zu_ice   = u_ice(ji,jj-1) - u_oce(ji,jj-1)
-               zv_ice   = v_ice(ji,jj-1) - v_oce(ji,jj-1)
-               zt21  = rhoco * ( zu_ice * zu_ice + zv_ice * zv_ice ) 
-
-               zu_ice   = u_ice(ji,jj) - u_oce(ji,jj)
-               zv_ice   = v_ice(ji,jj) - v_oce(ji,jj)
-               zt22  = rhoco * ( zu_ice * zu_ice + zv_ice * zv_ice ) 
-
-               ztair2 = gtaux(ji,jj) * gtaux(ji,jj) + gtauy(ji,jj) * gtauy(ji,jj)
-
-               zustm =  ( 1 - frld(ji,jj) ) * 0.25 * ( zt11 + zt12 + zt21 + zt22 )        &
-                  &  +        frld(ji,jj)   * SQRT( ztair2 )
-
-               ust2s(ji,jj) = ( zustm / rau0 ) * ( rone + sdvt(ji,jj) ) * tms(ji,jj)
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               ust2s(ji,jj) = zcoef * tms(ji,jj) * SQRT(  utau(ji,jj) * utau(ji,jj) + utau(ji-1,jj) * utau(ji-1,jj)   &
+                  &                                     + vtau(ji,jj) * vtau(ji,jj) + vtau(ji,jj-1) * vtau(ji,jj-1) )
             END DO
          END DO
-
-       ELSE      ! no ice dynamics : transmit directly the atmospheric stress to the ocean
-                    
-          DO jj = 2, jpjm1
-             DO ji = 2, jpim1
-#if defined key_coupled && defined key_lim_cp1
-                tio_u(ji,jj) = - (  gtaux(ji  ,jj  ) + gtaux(ji-1,jj  )       &
-                   &              + gtaux(ji-1,jj-1) + gtaux(ji  ,jj-1) ) / ( 4 * rau0 )
-
-                tio_v(ji,jj) = - (  gtauy(ji  ,jj )  + gtauy(ji-1,jj  )       &
-                   &              + gtauy(ji-1,jj-1) + gtauy(ji  ,jj-1) ) / ( 4 * rau0 )
-#else
-                tio_u(ji,jj) = - gtaux(ji,jj) / rau0
-                tio_v(ji,jj) = - gtauy(ji,jj) / rau0 
-#endif
-                ztair2       = gtaux(ji,jj) * gtaux(ji,jj) + gtauy(ji,jj) * gtauy(ji,jj)
-                zustm        = SQRT( ztair2  )
-
-                ust2s(ji,jj) = ( zustm / rau0 ) * ( rone + sdvt(ji,jj) ) * tms(ji,jj)
-            END DO
-         END DO
-
+         !
       ENDIF
-
+      !
       CALL lbc_lnk( ust2s, 'T',  1. )   ! T-point
-      CALL lbc_lnk( tio_u, 'I', -1. )   ! I-point (i.e. ice U-V point)
-      CALL lbc_lnk( tio_v, 'I', -1. )   ! I-point (i.e. ice U-V point)
-
-      IF(ln_ctl) THEN 
-            CALL prt_ctl(tab2d_1=tio_u , clinfo1=' lim_dyn  : tio_u :', tab2d_2=tio_v , clinfo2=' tio_v :')
-            CALL prt_ctl(tab2d_1=ust2s , clinfo1=' lim_dyn  : ust2s :')
-      ENDIF
+      !
+      IF(ln_ctl)   CALL prt_ctl(tab2d_1=ust2s , clinfo1=' lim_dyn  : ust2s :')
 
    END SUBROUTINE lim_dyn_2
@@ -257,14 +190,11 @@
       !!                  ***  ROUTINE lim_dyn_init_2  ***
       !!
-      !! ** Purpose : Physical constants and parameters linked to the ice
-      !!      dynamics
-      !!
-      !! ** Method  :  Read the namicedyn namelist and check the ice-dynamic
-      !!       parameter values called at the first timestep (nit000)
+      !! ** Purpose :   Physical constants and parameters linked to the ice
+      !!              dynamics
+      !!
+      !! ** Method  :   Read the namicedyn namelist and check the ice-dynamic
+      !!              parameter values
       !!
       !! ** input   :   Namelist namicedyn
-      !!
-      !! history :
-      !!  8.5  ! 03-08 (C. Ethe) original code
       !!-------------------------------------------------------------------
       NAMELIST/namicedyn/ epsd, alpha,     &
@@ -273,11 +203,8 @@
       !!-------------------------------------------------------------------
 
-      ! Define the initial parameters
-      ! -------------------------
-
-      ! Read Namelist namicedyn
-      REWIND ( numnam_ice )
+      REWIND ( numnam_ice )                       ! Read Namelist namicedyn
       READ   ( numnam_ice  , namicedyn )
-      IF(lwp) THEN
+
+      IF(lwp) THEN                                ! Control print
          WRITE(numout,*)
          WRITE(numout,*) 'lim_dyn_init_2: ice parameters for ice dynamics '
@@ -291,5 +218,5 @@
          WRITE(numout,*) '       maximum value for the residual of relaxation     resl   = ', resl
          WRITE(numout,*) '       drag coefficient for oceanic stress              cw     = ', cw
-         WRITE(numout,*) '       turning angle for oceanic stress                 angvg  = ', angvg
+         WRITE(numout,*) '       turning angle for oceanic stress                 angvg  = ', angvg, ' degrees'
          WRITE(numout,*) '       first bulk-rheology parameter                    pstar  = ', pstar
          WRITE(numout,*) '       second bulk-rhelogy parameter                    c_rhg  = ', c_rhg
@@ -303,14 +230,12 @@
       usecc2 = 1.0 / ( ecc * ecc )
       rhoco  = rau0 * cw
-      angvg  = angvg * rad
+      angvg  = angvg * rad      ! convert angvg from degree to radian
       sangvg = SIN( angvg )
       cangvg = COS( angvg )
       pstarh = pstar / 2.0
-      sdvt(:,:) = 0.e0
-
-      !  Diffusion coefficients.
-      ahiu(:,:) = ahi0 * umask(:,:,1)
+      !
+      ahiu(:,:) = ahi0 * umask(:,:,1)            ! Ice eddy Diffusivity coefficients.
       ahiv(:,:) = ahi0 * vmask(:,:,1)
-
+      !
    END SUBROUTINE lim_dyn_init_2
 
Index: trunk/NEMO/LIM_SRC_2/limhdf_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limhdf_2.F90	(revision 833)
+++ trunk/NEMO/LIM_SRC_2/limhdf_2.F90	(revision 888)
@@ -6,5 +6,5 @@
 #if defined key_lim2
    !!----------------------------------------------------------------------
-   !!   'key_lim2'  i                                 LIM 2.0 sea-ice model
+   !!   'key_lim2'                                    LIM 2.0 sea-ice model
    !!----------------------------------------------------------------------
    !!   lim_hdf_2  : diffusion trend on sea-ice variable
@@ -34,5 +34,5 @@
    !!----------------------------------------------------------------------
    !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $ Id: $
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
Index: trunk/NEMO/LIM_SRC_2/limistate_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limistate_2.F90	(revision 833)
+++ trunk/NEMO/LIM_SRC_2/limistate_2.F90	(revision 888)
@@ -4,7 +4,9 @@
    !!              Initialisation of diagnostics ice variables
    !!======================================================================
-   !! History :   2.0  !  01-04  (C. Ethe, G. Madec)  Original code
+   !! History :   1.0  !  01-04  (C. Ethe, G. Madec)  Original code
+   !!             2.0  !  03-08  (G. Madec)  add lim_istate_init
    !!                  !  04-04  (S. Theetten) initialization from a file
    !!                  !  06-07  (S. Masson)  IOM to read the restart
+   !!                  !  07-10  (G. Madec)  surface module
    !!--------------------------------------------------------------------
 #if defined key_lim2
@@ -18,10 +20,9 @@
    USE phycst
    USE ocfzpt
-   USE oce             ! dynamics and tracers variables      !!gm used???
-   USE dom_oce                                                     !!gm used???
    USE par_ice_2       ! ice parameters
    USE ice_oce         ! ice variables
    USE dom_ice_2
    USE lbclnk
+   USE oce
    USE ice_2
    USE iom
@@ -47,5 +48,5 @@
    !!----------------------------------------------------------------------
    !!   LIM 2.0,  UCL-LOCEAN-IPSL (2006) 
-   !! $Header$ 
+   !! $ Id: $
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -66,46 +67,8 @@
       REAL(wp), DIMENSION(jpi,jpj) ::   ztn   ! workspace
       !--------------------------------------------------------------------
-
-       CALL lim_istate_init_2   !  reading the initials parameters of the ice
-
-      !-- Initialisation of sst,sss,u,v do i=1,jpi
-      u_io(:,:)  = 0.e0       ! ice velocity in x direction
-      v_io(:,:)  = 0.e0       ! ice velocity in y direction
-
-      IF( ln_limini ) THEN    ! 
-        
-         ! Initialisation at tn if no ice or sst_ini if ice
-         ! Idem for salinity
-
-      !--- Criterion for presence (zidto=1.) or absence (zidto=0.) of ice
-         DO jj = 1 , jpj
-            DO ji = 1 , jpi
-               
-               zidto = MAX(zzero, - SIGN(1.,frld(ji,jj) - 1.))
-               
-               sst_io(ji,jj) = ( nfice - 1 ) * (zidto * sst_ini(ji,jj)  + &   ! use the ocean initial values
-                    &          (1.0 - zidto ) * ( tn(ji,jj,1) + rt0 ))        ! tricky trick *(nfice-1) !
-               sss_io(ji,jj) = ( nfice - 1 ) * (zidto * sss_ini(ji,jj) + &
-                    &          (1.0 - zidto ) *  sn(ji,jj,1) )
-
-               ! to avoid the the melting of ice, several layers (mixed layer) should be
-               ! set to sst_ini (sss_ini) if there is ice
-               ! example for one layer 
-               ! tn(ji,jj,1) = zidto * ( sst_ini(ji,jj) - rt0 )  + (1.0 - zidto ) *  tn(ji,jj,1)
-               ! sn(ji,jj,1) = zidto * sss_ini(ji,jj)  + (1.0 - zidto ) *  sn(ji,jj,1)
-               ! tb(ji,jj,1) = tn(ji,jj,1)
-               ! sb(ji,jj,1) = sn(ji,jj,1)
-            END DO
-         END DO
-         
-         
-         !  tfu: Melting point of sea water
-         tfu(:,:)  = ztf   
-         
-         tfu(:,:)  = ABS ( rt0 - 0.0575       * sss_ini(:,:)                               &
-              &                    + 1.710523e-03 * sss_ini(:,:) * SQRT( sss_ini(:,:) )    &
-              &                    - 2.154996e-04 * sss_ini(:,:) * sss_ini(:,:) )
-      ELSE                     !
-
+ 
+      CALL lim_istate_init_2     !  reading the initials parameters of the ice
+
+      IF( .NOT. ln_limini ) THEN  
          
          ! Initialisation at tn or -2 if ice
@@ -116,18 +79,9 @@
             END DO
          END DO
-         
-         u_io  (:,:) = 0.e0
-         v_io  (:,:) = 0.e0
-         sst_io(:,:) = ( nfice - 1 ) * ( tn(:,:,1) + rt0 )   ! use the ocean initial values
-         sss_io(:,:) = ( nfice - 1 ) *   sn(:,:,1)           ! tricky trick *(nfice-1) !
-         
-         ! reference salinity 34psu
+                  
+         !  tfu: Melting point of sea water [Kelvin]
          zs0 = 34.e0
-         ztf = ABS ( rt0 - 0.0575       * zs0                           &
-              &                    + 1.710523e-03 * zs0 * SQRT( zs0 )   &
-              &                    - 2.154996e-04 * zs0 *zs0          )
-         
-         !  tfu: Melting point of sea water
-         tfu(:,:)  = ztf   
+         ztf = rt0 + ( - 0.0575 + 1.710523e-3 * SQRT( zs0 ) - 2.154996e-4 * zs0 ) * zs0
+         tfu(:,:) = ztf
          
          DO jj = 1, jpj
@@ -152,10 +106,11 @@
          tbif  (:,:,2) = tfu(:,:)
          tbif  (:,:,3) = tfu(:,:)
-      
+
       ENDIF
+     
       fsbbq (:,:)   = 0.e0
       qstoif(:,:)   = 0.e0
-      u_ice (:,:)   = 0.e0
-      v_ice (:,:)   = 0.e0
+      ui_ice(:,:)   = 0.e0
+      vi_ice(:,:)   = 0.e0
 # if defined key_coupled
       albege(:,:)   = 0.8 * tms(:,:)
@@ -191,5 +146,5 @@
 
       CALL lbc_lnk( hsnif, 'T', 1. )
-      CALL lbc_lnk( sist , 'T', 1. )
+      CALL lbc_lnk( sist , 'T', 1. , pval = rt0 )      ! set rt0 on closed boundary (required by bulk formulation)
       DO jk = 1, jplayersp1
          CALL lbc_lnk(tbif(:,:,jk), 'T', 1. )
@@ -197,6 +152,5 @@
       CALL lbc_lnk( fsbbq  , 'T', 1. )
       CALL lbc_lnk( qstoif , 'T', 1. )
-      CALL lbc_lnk( sss_io , 'T', 1. )
-      !
+
    END SUBROUTINE lim_istate_2
 
@@ -209,8 +163,5 @@
       !!
       !! ** Method  :   Read the namiceini namelist and check the parameter 
-      !!                values called at the first timestep (nit000)
-      !!                or
-      !!                Read 7 variables from a previous restart file
-      !!                sst, sst, hicif, hsnif, frld, ts & tbif
+      !!       values called at the first timestep (nit000)
       !!
       !! ** input   :   Namelist namiceini
@@ -222,43 +173,34 @@
          &                hnins, hgins, alins
       !!-------------------------------------------------------------------
-      
-      ! Read Namelist namiceini 
-      REWIND ( numnam_ice )
+      !
+      REWIND ( numnam_ice )               ! Read Namelist namiceini 
       READ   ( numnam_ice , namiceini )
-      
-      IF(.NOT. ln_limini) THEN 
-         IF(lwp) THEN
-            WRITE(numout,*)
-            WRITE(numout,*) 'lim_istate_init : ice parameters inititialisation '
-            WRITE(numout,*) '~~~~~~~~~~~~~~~'
-            WRITE(numout,*) '         threshold water temp. for initial sea-ice    ttest      = ', ttest
-            WRITE(numout,*) '         initial snow thickness in the north          hninn      = ', hninn
-            WRITE(numout,*) '         initial ice thickness in the north           hginn      = ', hginn 
-            WRITE(numout,*) '         initial leads area in the north              alinn      = ', alinn            
-            WRITE(numout,*) '         initial snow thickness in the south          hnins      = ', hnins 
-            WRITE(numout,*) '         initial ice thickness in the south           hgins      = ', hgins
-            WRITE(numout,*) '         initial leads area in the south              alins      = ', alins
-         ENDIF
+      !
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'lim_istate_init_2 : ice parameters inititialisation '
+         WRITE(numout,*) '~~~~~~~~~~~~~~~~~'
+         WRITE(numout,*) '         threshold water temp. for initial sea-ice    ttest      = ', ttest
+         WRITE(numout,*) '         initial snow thickness in the north          hninn      = ', hninn
+         WRITE(numout,*) '         initial ice thickness in the north           hginn      = ', hginn 
+         WRITE(numout,*) '         initial leads area in the north              alinn      = ', alinn            
+         WRITE(numout,*) '         initial snow thickness in the south          hnins      = ', hnins 
+         WRITE(numout,*) '         initial ice thickness in the south           hgins      = ', hgins
+         WRITE(numout,*) '         initial leads area in the south              alins      = ', alins
+         WRITE(numout,*) '         Ice state initialization using input file    ln_limini  = ', ln_limini
       ENDIF
 
       IF( ln_limini ) THEN                      ! Ice initialization using input file
-
+         !
          CALL iom_open( 'Ice_initialization.nc', inum_ice )
-
+         !
          IF( inum_ice > 0 ) THEN
-            IF(lwp) THEN
-               WRITE(numout,*) ' '
-               WRITE(numout,*) 'lim_istate_init : ice state initialization with : Ice_initialization.nc'
-               WRITE(numout,*) '~~~~~~~~~~~~~~~'
-               WRITE(numout,*) '         Ice state initialization using input file    ln_limini  = ', ln_limini
-               WRITE(numout,*) ' '
-            ENDIF
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) '                  ice state initialization with : Ice_initialization.nc'
             
-            CALL iom_get( inum_ice, jpdom_data, 'sst'  , sst_ini(:,:) )        
-            CALL iom_get( inum_ice, jpdom_data, 'sss'  , sss_ini(:,:) )       
-            CALL iom_get( inum_ice, jpdom_data, 'hicif', hicif  (:,:) )      
-            CALL iom_get( inum_ice, jpdom_data, 'hsnif', hsnif  (:,:) )      
-            CALL iom_get( inum_ice, jpdom_data, 'frld' , frld   (:,:) )     
-            CALL iom_get( inum_ice, jpdom_data, 'ts'   , sist   (:,:) )
+            CALL iom_get( inum_ice, jpdom_data, 'hicif', hicif )      
+            CALL iom_get( inum_ice, jpdom_data, 'hsnif', hsnif )      
+            CALL iom_get( inum_ice, jpdom_data, 'frld' , frld  )     
+            CALL iom_get( inum_ice, jpdom_data, 'ts'   , sist  )
             CALL iom_get( inum_ice, jpdom_unknown, 'tbif', tbif(1:nlci,1:nlcj,:),   &
                  &        kstart = (/ mig(1),mjg(1),1 /), kcount = (/ nlci,nlcj,jplayersp1 /) )
@@ -268,8 +210,8 @@
 
             CALL iom_close( inum_ice)
-            
+            !
          ENDIF
       ENDIF
-      !
+      !     
    END SUBROUTINE lim_istate_init_2
 
Index: trunk/NEMO/LIM_SRC_2/limmsh_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limmsh_2.F90	(revision 833)
+++ trunk/NEMO/LIM_SRC_2/limmsh_2.F90	(revision 888)
@@ -25,5 +25,5 @@
    !!----------------------------------------------------------------------
    !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $ Id: $
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
